
/**
 * Title:        WebWatcher<p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
import java.io.*;
import no.shhsoft.awt.*;

public class BrowserLauncher implements Runnable {
  WebPage mWebPage;
  String  mCommand, mAlternateCommand;
  GUI mGUI;
  static long TIMEOUT = 10 * 1000;

  public BrowserLauncher(GUI gui, String command,String alternateCommand,WebPage page) {
        mWebPage = page;
        String  url = mWebPage.getURL().toString();
        mCommand =  insertURL(command,url);
        mAlternateCommand = insertURL(alternateCommand,url);
        mGUI = gui;
        Thread launcher = new Thread(this);
        launcher.setPriority(Thread.MIN_PRIORITY);
        launcher.setDaemon(true);
        launcher.start();
  }
    private static boolean launch(String command, StringBuffer message) throws IOException{
//      System.out.println(command);
            Process p = Runtime.getRuntime().exec(command);
            boolean error = false;
//              System.out.println("waiting");
            Interrupter interrupter = new Interrupter(Thread.currentThread(),TIMEOUT);
            try {
              p.waitFor();
              interrupter.ok();
//                System.out.println("ok");
            } catch(InterruptedException ie) {
//                              System.out.println("too long");
            }
             /*
*/
            try {
              if( p.exitValue() != 0 ) {
//                    System.out.println("exit != 0");
                error = true;
                message.append("Exit value == "+p.exitValue());
                BufferedReader br = new BufferedReader(new InputStreamReader(p.getErrorStream()));
//                  System.out.println("reading error log...");
                String line;
                while((line = br.readLine()) != null) {
                  message.append(line);
                }
//                  System.out.println("reading normal log...");
                br = new BufferedReader(new InputStreamReader(p.getInputStream()));
                while((line = br.readLine()) != null)
                  message.append(line);
//                  System.out.println("ok");
              }
            } catch (IllegalThreadStateException itse) {
                System.out.println(itse.toString());
            }
            return(error);
    }

    private static String insertURL(String origCommand, String url) {
        String command = new String();
        int idx = 0;
        for (int from = 0; ; ) {
            if ((idx = origCommand.indexOf("%u", from)) < 0)
                idx = origCommand.indexOf("%U", from);
            if (idx < 0) {
                command += origCommand.substring(from, origCommand.length());
                break;
            } else {
                command += origCommand.substring(from, idx);
                command += url;
                from = idx + 2;
            }
        }
        return(command);

    }
  public void run() {

        boolean execOk = false;
        try {
           // System.out.println(command);
            StringBuffer message = new StringBuffer();
            boolean error = launch(mCommand,message);
//              System.out.println("error = "+error);
            if(error == true) {
              boolean SecondError = true;
              try {
                if(mAlternateCommand != null)
                  if(mAlternateCommand.length() > 0)
                    SecondError = launch(mAlternateCommand,message);
//              System.out.println("second error = "+SecondError);
                if (SecondError)
                  throw new IOException(message.toString());
                else
                  execOk = true;
              } catch(IOException ioe2) {
                ioe2.printStackTrace();
                throw new IOException(message.toString());
              }

            } else
              execOk = true;
        } catch (IOException e) {
e.printStackTrace();
            MessageBox.error(mGUI,"Unable to start browser: " + e.getMessage());
            execOk = false;
        }
        if (execOk)
            mWebPage.markAsSeen();


  }
}
